<?php
/*
|-----------------
| Home Automation Package by Eric Praske
|------------------
| This header must not be deleted or modified if you wish to use this script or any part of it.
|
*/

// Prereqs

require_once 'config.php';
    
	// Here we use phpgraphlib, but you can use other graphing classes
	include_once('includes/phpgraphlib.php');
	$graph = new PHPGraphLib(800,400);
    
	function toArray(SimpleXMLElement $xml) {
         $array = (array)$xml;

         foreach ( array_slice($array, 0) as $key => $value ) {
             if ( $value instanceof SimpleXMLElement ) {
                 $array[$key] = empty($value) ? NULL : toArray($value);
             }
         }
         return $array;
    }
	
	function read_file($file, $lines, $mode) {
		$handle = fopen($file, "r");
		// $linecounter = $lines;
		$text = array();
			
			for($x_pos = 0, $ln = 0, $output = array(); fseek($handle, $x_pos, SEEK_END) !== -1; $x_pos--) {
				
				$char = fgetc($handle);
				if ($char === "\n" && $output[$ln] != NULL) {
					list($date, $cool, $heat) = explode("\t", $output[$ln]);
					if($mode == "COOL") {	$text[$date] = $cool; }
					if($mode == "HEAT") {
						$heat_processed = preg_replace( "/\r|\n/", "", $heat );
						$text[$date] = $heat_processed; }
					$ln++;
					$lines --;
				}
				if ($lines == 0) { break; }
			$output[$ln] = $char . ((array_key_exists($ln, $output)) ? $output[$ln] : '');
			}
		fclose ($handle);
		return array_reverse($text);
	}

	if(isset($_POST['tstat_list'])) {
		$data = read_file('tstat.log', $_POST['tstat_list'], $_POST['mode']);
		$graph->setTitle('Thermostat Usage (Hours)');
	}
	
	if(isset($_POST['monostrip_list'])) {
		$energy = simplexml_load_file("http://$monoip/0/energy.xml?period=$_POST[monostrip_list]");
		$usage = $energy->socket[0];
		$result = toArray($usage);
		$data = $result['energy'];
		$graph->setTitle('Monostrip Usage (Watts)');
	}
    
    $graph->addData($data);
	$graph->setGradient('red', 'maroon');
	
	$graph->createGraph();
?>