<?php
/*
|-----------------
| Home Automation Package by Eric Praske
|------------------
| This header must not be deleted or modified if you wish to use this script or any part of it.
|
*/
	
// Prereqs

require_once 'config.php';
require_once 'updater.php';

// Check online status

function get_http_response_code($url) {
	$headers = get_headers($url);
	return substr($headers[0], 9, 3);
}

?>
<article class="first"><h2>Monostrip Outlet</h2>
<?php

//see if any action needs to be taken
if(isset($_POST['submit'])) {
	simplexml_load_file("http://$monoip/0/set.xml?value=$_POST[submit]");
	sleep(2);
}

if(get_http_response_code("http://$monoip") == "200") {
	//read the socket
		$mono = simplexml_load_file("http://$monoip/watts.xml");
		$status = simplexml_load_file("http://$monoip/status.xml");
		$state = $status->status[0]->socket[0]->state;

	//determine variables
	if($state == "ON") {
		$name = "OFF";
		$value = "Turn OFF";
	} else {
		$name = "ON";
		$value = "Turn ON";
	}

	echo "Current consumption (watts): " . $mono->watts . "<p>";

	//spit out result
	if(isset($_POST['submit'])) {
		echo "Socket switched " . $_POST['submit'] . "<p>";
	} else { print "Socket currently $state"; }	
	?>
	<p>
	<form name="form1" method="POST" action="<?php echo $_SERVER['PHP_SELF'] ?>">
	<input type="hidden" name="submit" value="<?php echo $name ?>">
	<input type="submit" value="<?php echo $value ?>" class="button">
	</form>
	<p>
	Historical data graphed according to the specified time frame.<br>
	<form action="/graphit.php" method="POST">
	<select name="monostrip_list">
	   <option value="hour">Hour</option>
	   <option value="day">Day</option>
	   <option value="week">Week</option>
	   <option value="month">Month</option>
	</select>
	<input type="submit" value="Generate Chart" class="button">
	</form>
<?php } else {
	echo "Unable to reach the Monostrip at this time";
} ?>
<p><h2>Thermostat</h2>
<p>
<?php
	
	$base_url = "http://$tstatip/tstat";

function tstat_read($base, $suffix) {
	$url = "$base/$suffix";
	$send_curl = curl_init($url);
	curl_setopt($send_curl, CURLOPT_URL, $url);
	curl_setopt($send_curl, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($send_curl, CURLOPT_HTTPHEADER,array('Accept: application/json', "Content-type: application/json")); 
	$json_response = curl_exec($send_curl); 
	// $status = curl_getinfo($send_curl, CURLINFO_HTTP_CODE); 
	curl_close($send_curl);
	$response = json_decode($json_response, true);
	return $response;
}

function tstat_set($url, $parameters) {
	
	$ch = curl_init( $url );
	curl_setopt( $ch, CURLOPT_POST, 1);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $parameters);
	curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt( $ch, CURLOPT_HEADER, 0);
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1);

	curl_exec( $ch );
	// Debugging...
	// $response = curl_exec( $ch );
	// echo "$response and $parameters";
	
}

// First see if any action
if(isset($_POST['away'])){
	$result = tstat_read("$base_url", "");
	if("$result[tmode]" == 1) {
		$parameters = '{"t_heat":50, "hold":1}';
		} else {
		$parameters = '{"t_cool":82, "hold":1}';
	}
	tstat_set("$base_url", "$parameters");
}

if(isset($_POST['home'])){
	$parameters = '{"hold":0}';
	tstat_set("$base_url", "$parameters");
}

$result2 = tstat_read("$base_url", "");

echo "Current temp: $result2[temp]<br>";

if("$result2[tmode]" == 0) {
	echo "Thermostat currently OFF";
	} else {

	if("$result2[tmode]" == 1) {
		$set_point = "$result2[t_heat]";
		} else {
		$set_point = "$result2[t_cool]";
	}
		
	echo "Set point: $set_point<p>";

	if("$result2[tmode]" == 1) $mode = "HEAT";
	if("$result2[tmode]" == 2) $mode = "COOL";
	echo "$mode"; ?> mode is active and the fan is currently
	<?php
	if("$result2[fstate]" == 0) echo " OFF.";
	if("$result2[fstate]" == 1) echo " ON.";
	?>
	<?php 
	// Change 82 and 50 to correspond to the cool and heat away set points if desired
	if("$result2[tmode]" == 2 && "$result2[t_cool]" < 82 OR "$result2[tmode]" == 1 && "$result2[t_heat]" > 50) { ?>
	<p>
	<form method="POST" action="<?php echo $_SERVER['PHP_SELF'] ?>">
	<input type="submit" name="away" value="Set Away Mode" class="button">
	</form>
	<?php } else { ?>
	<p>
	<form method="POST" action="<?php echo $_SERVER['PHP_SELF'] ?>">
	<td><input type="submit" name="home" value="Set Home Mode" class="button"></td>
	</form>
<?php } } ?>
<p>
Historical data graphed according to the specified time frame.<br>
<form action="graph.php" method="POST">
<input type="hidden" name="mode" value="<?php echo "$mode"; ?>">
<select name="tstat_list">
   <option value="7">Week</option>
   <option value="30">1 Month</option>
   <option value="60">2 Months</option>
</select>
<input type="submit" value="Generate Chart" class="button">
</form>
</article>