<?php
/*
|-----------------
| Home Automation Package by Eric Praske
|------------------
| This header must not be deleted or modified if you wish to use this script or any part of it.
|
*/

// Prereqs

require_once 'config.php';

// Global vars

	$base_url = "http://$tstatip/tstat";
	$key = "123";

// Verify API key

if(!isset($_GET['key']) OR $_GET['key'] != $key) die('Invalid API key');

//see if any action needs to be taken
if(isset($_GET['mono'])) {
	simplexml_load_file("http://$monoip/0/set.xml?value=$_GET[mono]");
	sleep(2);
}

if(isset($_GET['away'])){
	if("$result[tmode]" == 1) {
		$parameters = '{"t_heat":50, "hold":1}';
		} else {
		$parameters = '{"t_cool":82, "hold":1}';
	}
	tstat_set("$base_url", "$parameters");
	sleep(2);
}

if(isset($_GET['home'])){
	$parameters = '{"hold":0}';
	tstat_set("$base_url", "$parameters");
	sleep(2);
}

//read the socket
    $mono = simplexml_load_file("http://$monoip/watts.xml");
    $status = simplexml_load_file("http://$monoip/status.xml");
    $state = $status->status[0]->socket[0]->state;
	
//begin tstat functions
function tstat_read($base, $suffix) {
	$url = "$base/$suffix";
	$send_curl = curl_init($url);
	curl_setopt($send_curl, CURLOPT_URL, $url);
	curl_setopt($send_curl, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($send_curl, CURLOPT_HTTPHEADER,array('Accept: application/json', "Content-type: application/json")); 
	$json_response = curl_exec($send_curl); 
	// $status = curl_getinfo($send_curl, CURLINFO_HTTP_CODE); 
	curl_close($send_curl);
	$response = json_decode($json_response, true);
	return $response;
}

function tstat_set($url, $parameters) {
	
	$ch = curl_init( $url );
	curl_setopt( $ch, CURLOPT_POST, 1);
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $parameters);
	curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt( $ch, CURLOPT_HEADER, 0);
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1);

	curl_exec( $ch );
	// Useful for debugging
	// $response = curl_exec( $ch );
	// echo "$response and $parameters";
	
}
$result = tstat_read("$base_url", "");

if("$result[tmode]" == 1) {
		$set_point = "$result[t_heat]";
		} else {
		$set_point = "$result[t_cool]";
	}

if("$result[tmode]" == 0) $mode = "Thermostat is off";
if("$result[tmode]" == 1) $mode = "HEAT";
if("$result[tmode]" == 2) $mode = "COOL";
if("$result[fstate]" == 0) $fan = "OFF";
if("$result[fstate]" == 1) $fan = "ON";

$data = array('m_state' => "$state", 'm_usage' => "$mono->watts", 't_mode' => "$mode", 'f_state' => "$fan", 't_target' => "$set_point", 't_temp' => "$result[temp]");

// headers for not caching the results
header('Cache-Control: no-cache, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');

// headers to tell that result is JSON
header('Content-type: application/json');

// send the result now
echo json_encode($data);